# Manual Authorization

This function is used to request authorization in an offline scenario, which means that Shift4 will not seek processor approval. An authorization code should be included in this request if the amount being submitted in the request is greater than the authorization amount currently on file.

Integration Methods:
- Host Direct
- Locally Installed UTG
- Commerce Engine For On Premise
- Commerce Engine For Cloud

See the Integration Methods and URLs Section sections of the Development Quick Start guide for details regarding each processing option.

See the JSON Body Schemas for more details on the various JSON body formats.

Endpoint: POST /transactions/manualauthorization
Version: 1.7.56
Security: AccessToken

## Header parameters:

  - `InterfaceVersion` (string, required)
    Refers to the version of the program or application that is sending requests to Shift4. The following special characters are not allowed&colon;  $ % &colon; ^ - ~  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "2.1"

  - `InterfaceName` (string, required)
    Refers to the name of the program or application that is sending requests to Shift4. This should be the name of the program that you purchased or created. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ `  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "ForwardPOS"

  - `CompanyName` (string, required)
    Refers to the vendor or partner that designed and certified the interface. The information you use in this field should match what Shift4 has on file or what was agreed upon in your Integration Plan. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ `  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "PAWS"

  - `AccessToken` (string, required)
    A security credential used to authenticate API requests and all i4Go® authorizeClient/preauthorizeClient requests. An Access Token is the alias for the merchant account and interface being used. The Access Token is required in all requests except an Access Token Exchange request, which generates an Access Token using an authToken and clientGuid.
    Example: "EA79FB05-3AA7-4500-AF9A-73F986FF2C1D"

## Request fields (application/json):

  - `body` (object, required) — one of:
    - Commerce Engine For On Premise:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
        Example: "2021-04-15T09:18:23.283-07:00"
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested. All other fields are for informational purposes and must also be included in the total field. For example, a purchase of $100 with a $20 tip and $8 tax would be 128.00 in the total field, 20.00 in the tip field and 8.00 in the tax field.

Note: For merchants that are configured to allow multiple currencies, the amount  fields can specify up to three decimal places. However, the number of decimal  places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
        Example: {"tax":15,"total":140}
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
        Example: 140
      - `amount.tax` (number, required)
        The amount of sales tax charged for a transaction. The tax amount is used by businesses to track tax expenses for accounting purposes. Identifying the tax amount also helps consumers understand the total amount that they were billed.  This field is part of Level 2 card data.
        Example: 15
      - `amount.taxIndicator` (string)
        Value|Description
-----|-----------
Y    | Tax is included
N    | Tax is not included
        Enum: "Y", "N"
      - `amount.cashback` (number)
        Specifies the cashback amount in a transaction. When using a UTG-controlled PIN pad with the ALLOWCASHBACK API Option, this field will return the cashback amount requested by the consumer. The interface can also send the desired cashback amount in a request by adding it to the amount.total and including it in the amount.cashback field. This will bypass prompting the consumer for a cashback amount.
      - `amount.iiasAmounts` (array)
        Conditional: Send in the request if processing for a health care merchant.

For Vision related charges you must send only iiasAmounts.type = 4V and the corresponding iiasAmounts.amount value.

For all other charges, the first entry in the array should have an amount representing the total of all healthcare costs, and iiasAmounts.type = 4S.  Any subsequent entries should contain the subtotal for each of the other expense types involved in this transaction.
      - `amount.iiasAmounts.amount` (number)
        The subtotal for this type of healthcare expenses.
      - `amount.iiasAmounts.type` (string)
        This code classifies eligible healthcare expenses.

Value|Description
-----|-----------
4O   | Cash Disbursement (Discover Only) – Amount of Cash Back Being Requested
4S   | Healthcare (Visa/MC Only) – Qualified Medical Expenses or Over-the-Counter
4T   | Transit (Visa Only) – Transit Fare Media (e.g., Commuter and Parking Passes, Mass Transit Vouchers, and Tickets)
4U   | RX (Visa/MC Only)
4V   | Vision (Visa Only)
4W   | Clinical (Visa Only)
4X   | Dental (Visa Only)
        Enum: "4O", "4S", "4T", "4U", "4V", "4W", "4X"
      - `amount.tip` (number)
        Conditional: Send in the request if a tip is included.

The tip amount of the transaction.
      - `amount.checkTotal` (number)
        Optional field specifying the total amount of the entire bill/invoice that this transaction is part of. It can be larger than amount.total in scenarios where the check is being split or if a portion of the check was already paid in cash or another form of payment.
      - `clerk` (object, required)
        Example: {"numericId":1576}
      - `clerk.numericId` (integer, required)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
        Example: 1576
      - `transaction` (object, required)
        Example: {"hotel":{"estimatedDays":5},"invoice":"192029","authorizationCode":"189746","notes":"Transaction notes are added here","purchaseCard":{"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}}
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
        Example: "192029"
      - `transaction.purchaseCard` (object, required)
        Example: {"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}
      - `transaction.purchaseCard.customerReference` (string, required)
        A unique value used to identify the consumer or transaction. If a merchant has a significant amount of revenue from purchasing card customers, the interface would use this field to collect the consumer’s purchase order or employee identification number. In lodging transactions, this may be unique transaction details, such as a reservation code or third-party booking source.  This field is part of Level 2 card data.
        Example: "D019D09309F2"
      - `transaction.purchaseCard.destinationPostalCode` (string, required)
        When items are shipped, the ZIP/postal code to which merchandise will be shipped; otherwise, the ZIP/postal code where the goods or services are rendered.  This field is part of Level 2 card data.
        Example: "94719"
      - `transaction.purchaseCard.productDescriptors` (array, required)
        A text description of the items purchased or services sold. This can be a generic text description of what the merchant sells (such as “Groceries”) or specific transaction data (such as the name of the item sold). At least one product descriptor field is required in a sale or authorization request.

Note: The productDescriptors array is limited to 4 elements. Each element can contain a maximum of 40 characters.
        Example: ["Hamburger","Fries","Soda","Cookie"]
      - `transaction.authorizationCode` (string, required)
        The authorization code provided by the consumer’s issuing bank. It is provided in a response if an online authorization or sale request is approved. Following a referral response, it is also specified in [Manual Sale](/apis/payments-platform-rest/openapi/transactions/manualsale) requests.
        Example: "189746"
      - `transaction.manualTranId` (string)
        This is typically used in a Referral. If a ManualTranID is returned by the issuer with the Auth code, it should be sent to the processor in the ManualTranid field.
      - `transaction.notes` (string)
        A free-form notes field that supports the use of HTML tags.  This can be used for reference in [Lighthouse Transaction Manager](https://ltm.shift4test.com/) and is not sent to the authorization host. Escaped quotation marks should not be sent in the Notes field.
        Example: "Transaction notes are added here"
      - `transaction.businessDate` (string)
        Desired business date of a transaction. Include when overriding the existing business date of a transaction. The overriding date may be earlier or later than the existing date. (yyyy-mm-dd)
      - `transaction.amex` (object)
      - `transaction.amex.propertyCode` (string)
        The code that contains a Merchant-assigned store or location number (or name) that uniquely identifies where the transaction took place.
      - `transaction.auto` (object)
        Conditional: Utilize this object for Auto Rental transactions
      - `transaction.auto.estimatedDays` (integer)
        Estimated contract length of car rental.
      - `transaction.airline` (object)
        Conditional: Utilize this object for Airline transactions in Authorization/Sale requests when possible. If unable to provide this data at Authorization, this object must be sent in subsequent Capture requests for the transaction.
      - `transaction.airline.carrierCode` (string, required)
        The code of the airline carrier issuing the ticket.
      - `transaction.airline.carrierName` (string, required)
        The name of the airline carrier issuing the ticket.
      - `transaction.airline.conjunctionTicketIndicator` (string, required)
        Indicates whether the itinerary contains more than four segments of travel.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.documentType` (string, required)
        This field contains the airline Document Type code, which indicates the purpose of this transaction. This information may appear on the descriptive bill on the Cardmember's statement, or be used to resolve billing inquiries and disputes. The codes entered in the Transaction Type and Document Type fields are used together to describe the purpose of this transaction.

Value | Description 
------|---------------
01    | Passenger Ticket
02    | Additional Collection
03    | Excess Baggage
04    | Misc. Charge Order (MCO) / Prepaid Ticket Auth
05    | Special Service Ticket
06    | Supported Refund
07    | Unsupported Refund
08    | Lost Ticket Application
09    | Tour Order Voucher
10    | Ticket by Mail
11    | Undercharge Adjustment
12    | Group Ticket
13    | Exchange Adjustment
14    | SPD/Air Freight
15    | In-flight Adjustment
16    | Agency Passenger Ticket
17    | Agency Tour Order/Voucher
18    | Agency Misc. Charge Order (MCO)
19    | Agency Exchange Order
20    | Agency Group Ticket
21    | Debit Adjustment Duplicate Refund/Use
22    | In-flight Merchandise Ordered
23    | Catalogue Merchandise Ordered
24    | In-flight Phone Charges
25    | Frequent Flyer Fee/Purchase
26    | Kennel Charge
27    | Animal Transportation Charge
28    | Firearms Case
29    | Upgrade Charge
30    | Credit Unused Transportation
31    | Credit Class of Service Adjustment
32    | Credit Denied Boarding
33    | Credit Misc. Refund
34    | Credit Lost Ticket Refund
35    | Credit Exchange Refund
36    | Credit Overcharge Adjustment
37    | Credit Multiple Unused Tickets
38    | Exchange Order
39    | Self-Service Ticket(s)
41    | In-flight Duty Free Purchase
42    | Senior Citizen Discount Booklets
43    | Club Membership Fee
44    | Coupon Book
45    | In-flight Charges
46    | Tour Deposit
47    | Frequent Flyer Overnight Delivery Charge
48    | Frequent Flyer Fulfillment
49    | Small Package Delivery
50    | Vendor Sale
51    | Miscellaneous Tax(es) Fee(s)
52    | Travel Agency Fee
60    | Vendor Refund Credit
64    | Duty Free Sale
65    | Preferred Seat Upgrade
66    | Cabin Upgrade
67    | Lounge/Club Access or Day Pass
68    | Agent Assisted Reservation. Ticketing Fee
69    | Ticket Change or Cancel Fee
70    | Trip Insurance
71    | Unaccompanied Minor
72    | Standby Fee
73    | Curbside Baggage
74    | Inflight Medical Equipment
75    | Ticket or Pass Print Fee
76    | Checked Sporting/Special Equipment
77    | Dry Ice Fee
78    | Mail/Postage Fee
79    | Club Membership Fee - Temporary/Trial
80    | Frequent Flyer Activation/Reinstatement
81    | Gift Certificate
82    | Onboard/Inflight Prepaid Voucher
83    | Optional Services Fee
84    | Advanced Purchase - Excess Baggage
85    | Advanced Purchase - Preferred Seat Upgrade
86    | Advanced Purchase - Cabin Upgrade
87    | Advanced Purchase - Optional Services
88    | WiFi
89    | Packages
90    | Inflight Entertainment/Internet Access
91    | Overweight Bag Fee
92    | Sleep Sets
93    | Special Purchase Fee
        Enum: "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "60", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93"
      - `transaction.airline.electronicTicketIndicator` (string, required)
        Indicates if an electronic ticket was issued.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.internetIndicator` (string, required)
        Indicates if this is an internet transaction.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.issueDate` (string, required)
        The date the ticket was issued to the customer. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.numberOfCities` (number, required)
        The number of airports or cities for each leg on the ticket (including origination and destination cities).
      - `transaction.airline.numberOfCarriers` (number, required)
        This field contains the number of airline carriers.
      - `transaction.airline.numberOfPassengers` (number, required)
        The number of passengers in the transaction.
      - `transaction.airline.passengerArrivalDate` (string, required)
        Date that the ticket holder is scheduled to arrive at their destination at the time of issuance of the original ticket. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerDepartureDate` (string, required)
        Date that the ticket holder is scheduled to depart at the time of issuance of the original ticket. The date may be a future one.  The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerNameRecord` (string, required)
        A passenger name record (PNR) is a record in the database of a computer reservation system (CRS) that contains the itinerary for a passenger or a group of passengers travelling together
      - `transaction.airline.restrictedTicketIndicator` (string, required)
        Indicates whether this ticket is non-refundable.

Value  | Description       
-------|-------------------
0      | No restriction
1      | Restricted (non-refundable) ticket
        Enum: "0", "1"
      - `transaction.airline.ticketChangeIndicator` (string, required)
        Indicates why a ticket was changed.  This field should contain spaces or one of the below codes.

Value  | Description 
-------|---------------
C      | Change to existing ticket
N      | New ticket
        Enum: "C", "N"
      - `transaction.airline.ticketTranType` (string, required)
        This field contains the ticket transaction type code assigned to this transaction.

Value  | Description 
-------|---------------
TKT    | Ticket Purchase
REF    | Refund
EXC    | Exchange Ticket
MSC    | Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only)
        Enum: "TKT", "REF", "EXC", "MSC"
      - `transaction.airline.tickets` (array, required)
        Array of ticket number and passenger name. Note: At least one instance of ticket number and passenger name info should be provided.
      - `transaction.airline.tickets.passengerName` (string, required)
        Name of the passenger to whom the ticket was issued.  This field contains the Passenger Name in format:

SURNAME FIRSTNAME MIDDLEINITIAL TITLE

Example: "Doe Jane M Mrs"
      - `transaction.airline.tickets.ticketNumber` (string, required)
        The ticket number provided by the Carrier for the passenger.
      - `transaction.airline.tickets.ticketFare` (number, required)
        Ticket fare is the total amount for each ticket, including service fee or any other fee for each ticket.
      - `transaction.airline.flightLegs` (array, required)
        Array of flight trip leg info. Maximun 4 legs to a trip allowed. Note: At least one instance of flight trip leg info should be provided.
      - `transaction.airline.flightLegs.carrierCode` (string, required)
        Code indicating name of carrier (United Airlines, Jet Blue, etc.) for the leg.
      - `transaction.airline.flightLegs.destAirportCode` (string, required)
        Indicates destination city's airport code for the leg.
      - `transaction.airline.flightLegs.fare` (number, required)
        This field contains the total Fare for this trip segment. This is not the total amount billed to the customer.
      - `transaction.airline.flightLegs.fareBasis` (string, required)
        This field contains primary and secondary discount codes that indicate the class of service and fare level associated with the ticket for the leg. Truncate at 24 bytes, if necessary.
      - `transaction.airline.flightLegs.flightNumber` (string, required)
        Number of the airline flight to be taken on Leg of the trip.
      - `transaction.airline.flightLegs.legArrivalDateTime` (string, required)
        The date and time the flight is scheduled to arrive for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.legDepartureDateTime` (string, required)
        The date and time the flight is scheduled to depart for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.originAirportCode` (string, required)
        Indicates origination city's airport code for the leg.
      - `transaction.airline.flightLegs.serviceClass` (string, required)
        Indicates service class for leg.

Value  | Description 
-------|---------------
FC     | First Class
BC     | Business Class
EC     | Economy/Coach Class
      - `transaction.airline.flightLegs.stopOverCode` (string, required)
        Indicates whether a stopover is allowed on this ticket for leg. The entry must be a D, O, or X.

Value  | Description 
-------|---------------
O      | Stopover allowed
X      | Stopover not allowed
D      | Destination point
      - `transaction.airline.flightLegs.tripLegInfo` (string, required)
        Description of leg or stage of trip.
      - `transaction.airline.flightLegs.couponNumber` (number)
        Number of coupons in the ticket for the leg.
      - `transaction.airline.typeIndicator` (string, required)
        Indicates if this ticket is a round trip, multi-city, or one-way ticket. 

Value  | Description 
-------|---------------
R      | Round-Trip
O      | One Way
M      | Multi-City
        Enum: "R", "O", "M"
      - `transaction.airline.ancillaryServices` (array)
        Array of ancillary service code and fees.

Conditional: Send if any ancillary services were charged.
      - `transaction.airline.ancillaryServices.serviceCode` (string, required)
        This field describes the type of service that has been provided.

Value | Description 
------|---------------
BF    | Bundled Service
BG    | Baggage Fee
CF    | Change Fee
CG    | Cargo
CO    | Carbon Offset
FF    | Frequent Flyer
GF    | Gift Card
GT    | Ground Transport
IE    | In-Flight Entertainment
LG    | Lounge
MD    | Medical
ML    | Meal/Beverage
OT    | Other
PA    | Passenger Assist Fee
PT    | Pets
SA    | Seat Fees
SB    | Standby
SF    | Service Fee
ST    | Store
TS    | Travel Service
UN    | Unaccompanied Travel
UP    | Upgrades
WI    | Wi-Fi
        Enum: "BF", "BG", "CF", "CG", "CO", "FF", "GF", "GT", "IE", "LG", "MD", "ML", "OT", "PA", "PT", "SA", "SB", "SF", "ST", "TS", "UN", "UP", "WI"
      - `transaction.airline.ancillaryServices.serviceFee` (number, required)
        This field contains the amount associated with the value provided in ancillary Service Code.
      - `transaction.airline.travelAgencyCode` (string)
        Code identifying travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.travelAgencyName` (string)
        Name of travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.exchangeTicketNumber` (string)
        The original ticket number that was replaced by a new ticket number.
      - `transaction.cardOnFile` (object)
        Conditional: Send this object when the transaction being performed is using a card on file or when the request will result in storing a card on file.

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for more information.
      - `transaction.cardOnFile.type` (string)
        This field specifies the type of the card-on-file transaction.

Below is a table showing the valid values for use cases where the cardholder is entering their card data to store on file.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| S01    | Cardholder | No        | Yes       | Used when the initial transaction/card verification request is not for a recurring payment.                                                                                                                                                                                                                                                                                        |
| S02    | Cardholder | Yes       | Yes       | Used when the initial transaction/card verification request is for a recurring payment. Requires sending cardOnFile.recurringFrequency and cardOnFile.recurringExpiry                                                                                                                                                                                              |

Below is a table showing the valid values for uses cases where you already have a card on file and are using that existing card to process a transaction.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| U01    | Cardholder | No        | Yes       | Unscheduled transaction using the card on file initiated by the cardholder                                                                                                                                                                                                                                                                                      |
| U02    | Merchant   | No        | No        | Unscheduled transaction using the card on file initiated by the merchant                                                                                                                                                                                                                                                                                        |
| U03    | Merchant   | Yes       | No        | Merchant initiated recurring payment using the card on file                                                                                                                                                                                                                                                                                                     |
| U04    | Merchant   | No        | No        | Identifies a transaction as a Reauthorization COF transaction.                                                                                                                                                                                                                                                                                                  |
| U05    | Merchant   | No        | No        | Identifies a transaction as a Resubmission COF transaction. Only certain merchant categories are able to send a resubmission, and it can only be done if the original authorization attempt was declined due to insufficient funds.                                                                                                                             |
| U06    | Merchant   | No        | No        | Identifies a transaction as an Estimated Authorization COF transaction.                                                                                                                                                                                                                                                                                         |
| U07    | Merchant   | No        | No        | Identifies a transaction as a Delayed Charges COF transaction. For example, a hotel might charge a customer for room damages after the guest has already checked out.                                                                                                                                                                                           |
| U08    | Merchant   | No        | No        | Identifies a transaction as an Incremental COF transaction. For example, a hotel which authorized a customer’s card for one night at check-in might increase the authorization amount to cover two nights when the customer decides to extend their stay. Shift4 automatically detects this scenario and sends the appropriate value to the processor. |
| U09    | Merchant   | No        | No        | Identifies a transaction as a No Show COF transaction. For example, a hotel might charge a customer who does not show up for a booked stay.                                                                                                                                                                                                                     |

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for additional details.
        Enum: "S01", "S02", "U01", "U02", "U03", "U04", "U05", "U06", "U07", "U08", "U09"
      - `transaction.cardOnFile.recurringExpiry` (string)
        Date after which no further authorizations shall be performed. This field is limited to 8 characters, and the accepted format is YYYYMMDD.

Conditional: This field is required if it's the first recurring transaction (cardOnFile.type = S02). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.
      - `transaction.cardOnFile.recurringFrequency` (string)
        Indicates the minimum number of days between authorizations.

Conditional: 'This field is required if it's the first recurring transaction (cardOnFile.type = S02). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.
      - `transaction.cardOnFile.transactionId` (string)
        This field is returned in the initial COF response, and ties subsequent COF transactions to the original authorization.

For example, if a merchant runs a Sale on a card for the first time, they will receive a transactionId back in the response.  A month later, when the merchant wants to perform an additional Sale with the card on file, they would send a Sale request including the transactionId they received from the first sale.

Conditional: Must be sent in subsequent COF requests if you are not processing with a Global Token Vault token. If using Global Token Vault tokens then this field is not required
      - `transaction.hotel` (object)
        Conditional: Utilize this object for Hotel transactions
        Example: {"estimatedDays":5}
      - `transaction.hotel.estimatedDays` (integer)
        Used to communicate the estimated number of days of a guest’s stay. This value is included in an [Authorization](/apis/payments-platform-rest/openapi/transactions/transactionsauthorization) request for a consumer’s hotel stay.
        Example: 5
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `device` (object)
      - `device.terminalId` (string)
        This field is optional and is for backwards compatibility with existing vendors that are used to processing via UTG controlled devices.

Since Commerce Engine is running directly on the payment device it does not require a device.terminalId to be specified.
      - `customer` (object)
      - `customer.addressLine1` (string)
        Cardholder’s street address exactly as it appears on their billing statement. This field is used in AVS.
      - `customer.firstName` (string)
        Specifies a consumer’s first name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the customer object, the consumer's name will be returned in the customer object if the name is present in the card's EMV or track data.
      - `customer.middleName` (string)
        Specifies a consumer’s middle name.
      - `customer.lastName` (string)
        Specifies a consumer’s last name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the customer object, the consumer's name will be returned in the customer object if the name is present in the card's EMV or track data.
      - `customer.postalCode` (string)
        Cardholder’s ZIP/postal code from their billing statement. This field is used in AVS. Do not include special characters.

Note: This field only allows alphanumeric characters (a-z, A-Z, 0-9). Special characters including - are not allowed. If you are sending in zip+4 you must not include the dash so 89134-1234 would be sent as 891341234
      - `customer.emailAddress` (string)
        Customer email address.
      - `customer.ipAddress` (string)
        Public source IP Address where the request originates, not the IP Address of the web server.
      - `card` (object)
        Example: {"present":"Y"}
      - `card.present` (string)
        Conditional: Send in the initial authorization/sale request

Indicates whether a card was present (‘Y’) or not (‘N’) at the time a transaction took place. This should be set appropriately in the initial authorization/sale request.  In subsequent requests, this field should be left blank or should not be sent.

Note: Subsequent request here does not apply to the secondary request for card on file type transactions or reuse of the same card. An example of a subsequent request would be a capture after an authorization. You would not include card.present in the capture, which is the subsequent request. Another example is when performing an incremental authorization where you perform an authorization, followed by an incremental authorization then a capture. The second authorization (incremental) and the capture are the subsequent requests where you would not include card.present.
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `card.type` (string)
        An abbreviation used to specify the type of card that will be used when processing a transaction.  If an interface sends a value that is not listed here, that value will be ignored.

Value| Description
-----|------------
CC   | When using a UTG-controlled device, this value will force a card to process as credit.
DB   | When using a UTG-controlled device, this value will force a card to process as debit.  When using a non-UTG-controlled PIN pad, this value must be sent when processing a debit transaction.
GC   | Gift Card
HF   | HSA/FSA Card
PL   | Private Label
YC   | IT’S YOUR CARD
        Enum: "CC", "DB", "GC", "HF", "PL", "YC"
      - `receiptColumns` (integer)
        Send this field if you want Shift4 to format the receipt text instead of returning individual fields. The value sent will correlate to the column width of the formatted receipt that we return. (This also allows the receipt text to wrap to fit the paper size of the printed receipt.) See the [Printing Receipts](/guides/core-concepts/printing-receipts) section of this document for more information on formatted receipts.
      - `currencyCode` (string)
        Transaction currency code. See the [Currency Codes](/guides/appendices/currency-codes) section for details.

Note: This is currently supported when processing for a merchant outside of the US and Canada. If processing for a US or Canadian merchant then this field will be ignored and the transaction will process in the merchant's configured currency.
      - `apiOptions` (array)
        API Options modify the request being made. See the [API Options](/guides/appendices/api-options.md) section for more information.
        Example: ["ALLOWPARTIALAUTH"]
      - `statementSuffix` (string)
        Custom description that will be appended to the merchant name on the customer's statement. For most card brands, the merchant DBA name can be a maximum of 25 characters. Sending this value will cause the merchant name to be truncated to 9 characters. Shift4 will add an asterisk between the merchant name and the statementSuffix value.

For example, for a merchant named Joe's Warehouse Emporium that processes a transaction with statementSuffix value of KDNYZUHQ1, the merchant statement will show as Joe's War*KDNYZUHQ1.

Note: The value that displays on customer statements from card issuers is beyond Shift4's control. We will submit the transaction data as described above, however issuers may modify or truncate that data as they see fit. To best accommodate different issuer limitations, we will truncate the merchant name to the minimum possible value (9 characters) in order to attempt to leave the most room for the statementSuffix to populate on issuer statements.
    - Commerce Engine For Cloud:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
        Example: "2021-04-15T09:18:23.283-07:00"
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested. All other fields are for informational purposes and must also be included in the total field. For example, a purchase of $100 with a $20 tip and $8 tax would be 128.00 in the total field, 20.00 in the tip field and 8.00 in the tax field.

Note: For merchants that are configured to allow multiple currencies, the amount  fields can specify up to three decimal places. However, the number of decimal  places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
        Example: {"tax":15,"total":140}
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
        Example: 140
      - `amount.tax` (number, required)
        The amount of sales tax charged for a transaction. The tax amount is used by businesses to track tax expenses for accounting purposes. Identifying the tax amount also helps consumers understand the total amount that they were billed.  This field is part of Level 2 card data.
        Example: 15
      - `amount.taxIndicator` (string)
        Value|Description
-----|-----------
Y    | Tax is included
N    | Tax is not included
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `amount.cashback` (number)
        Specifies the cashback amount in a transaction. When using a UTG-controlled PIN pad with the ALLOWCASHBACK API Option, this field will return the cashback amount requested by the consumer. The interface can also send the desired cashback amount in a request by adding it to the amount.total and including it in the amount.cashback field. This will bypass prompting the consumer for a cashback amount.
      - `amount.iiasAmounts` (array)
        Conditional: Send in the request if processing for a health care merchant.

For Vision related charges you must send only iiasAmounts.type = 4V and the corresponding iiasAmounts.amount value.

For all other charges, the first entry in the array should have an amount representing the total of all healthcare costs, and iiasAmounts.type = 4S.  Any subsequent entries should contain the subtotal for each of the other expense types involved in this transaction.
      - `amount.iiasAmounts.amount` (number)
        The subtotal for this type of healthcare expenses.
      - `amount.iiasAmounts.type` (string)
        This code classifies eligible healthcare expenses.

Value|Description
-----|-----------
4O   | Cash Disbursement (Discover Only) – Amount of Cash Back Being Requested
4S   | Healthcare (Visa/MC Only) – Qualified Medical Expenses or Over-the-Counter
4T   | Transit (Visa Only) – Transit Fare Media (e.g., Commuter and Parking Passes, Mass Transit Vouchers, and Tickets)
4U   | RX (Visa/MC Only)
4V   | Vision (Visa Only)
4W   | Clinical (Visa Only)
4X   | Dental (Visa Only)
        Enum: same as `amount.iiasAmounts.type` in "Commerce Engine For On Premise" (7 values)
      - `amount.tip` (number)
        Conditional: Send in the request if a tip is included.

The tip amount of the transaction.
      - `amount.checkTotal` (number)
        Optional field specifying the total amount of the entire bill/invoice that this transaction is part of. It can be larger than amount.total in scenarios where the check is being split or if a portion of the check was already paid in cash or another form of payment.
      - `clerk` (object, required)
        Example: {"numericId":1576}
      - `clerk.numericId` (integer, required)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
        Example: 1576
      - `transaction` (object, required)
        Example: {"hotel":{"estimatedDays":5},"invoice":"192029","authorizationCode":"189746","notes":"Transaction notes are added here","purchaseCard":{"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}}
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
        Example: "192029"
      - `transaction.purchaseCard` (object, required)
        Example: {"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}
      - `transaction.purchaseCard.customerReference` (string, required)
        A unique value used to identify the consumer or transaction. If a merchant has a significant amount of revenue from purchasing card customers, the interface would use this field to collect the consumer’s purchase order or employee identification number. In lodging transactions, this may be unique transaction details, such as a reservation code or third-party booking source.  This field is part of Level 2 card data.
        Example: "D019D09309F2"
      - `transaction.purchaseCard.destinationPostalCode` (string, required)
        When items are shipped, the ZIP/postal code to which merchandise will be shipped; otherwise, the ZIP/postal code where the goods or services are rendered.  This field is part of Level 2 card data.
        Example: "94719"
      - `transaction.purchaseCard.productDescriptors` (array, required)
        A text description of the items purchased or services sold. This can be a generic text description of what the merchant sells (such as “Groceries”) or specific transaction data (such as the name of the item sold). At least one product descriptor field is required in a sale or authorization request.

Note: The productDescriptors array is limited to 4 elements. Each element can contain a maximum of 40 characters.
        Example: ["Hamburger","Fries","Soda","Cookie"]
      - `transaction.authorizationCode` (string, required)
        The authorization code provided by the consumer’s issuing bank. It is provided in a response if an online authorization or sale request is approved. Following a referral response, it is also specified in [Manual Sale](/apis/payments-platform-rest/openapi/transactions/manualsale) requests.
        Example: "189746"
      - `transaction.manualTranId` (string)
        This is typically used in a Referral. If a ManualTranID is returned by the issuer with the Auth code, it should be sent to the processor in the ManualTranid field.
      - `transaction.notes` (string)
        A free-form notes field that supports the use of HTML tags.  This can be used for reference in [Lighthouse Transaction Manager](https://ltm.shift4test.com/) and is not sent to the authorization host. Escaped quotation marks should not be sent in the Notes field.
        Example: "Transaction notes are added here"
      - `transaction.businessDate` (string)
        Desired business date of a transaction. Include when overriding the existing business date of a transaction. The overriding date may be earlier or later than the existing date. (yyyy-mm-dd)
      - `transaction.amex` (object)
      - `transaction.amex.propertyCode` (string)
        The code that contains a Merchant-assigned store or location number (or name) that uniquely identifies where the transaction took place.
      - `transaction.auto` (object)
        Conditional: Utilize this object for Auto Rental transactions
      - `transaction.auto.estimatedDays` (integer)
        Estimated contract length of car rental.
      - `transaction.airline` (object)
        Conditional: Utilize this object for Airline transactions in Authorization/Sale requests when possible. If unable to provide this data at Authorization, this object must be sent in subsequent Capture requests for the transaction.
      - `transaction.airline.carrierCode` (string, required)
        The code of the airline carrier issuing the ticket.
      - `transaction.airline.carrierName` (string, required)
        The name of the airline carrier issuing the ticket.
      - `transaction.airline.conjunctionTicketIndicator` (string, required)
        Indicates whether the itinerary contains more than four segments of travel.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.documentType` (string, required)
        This field contains the airline Document Type code, which indicates the purpose of this transaction. This information may appear on the descriptive bill on the Cardmember's statement, or be used to resolve billing inquiries and disputes. The codes entered in the Transaction Type and Document Type fields are used together to describe the purpose of this transaction.

Value | Description 
------|---------------
01    | Passenger Ticket
02    | Additional Collection
03    | Excess Baggage
04    | Misc. Charge Order (MCO) / Prepaid Ticket Auth
05    | Special Service Ticket
06    | Supported Refund
07    | Unsupported Refund
08    | Lost Ticket Application
09    | Tour Order Voucher
10    | Ticket by Mail
11    | Undercharge Adjustment
12    | Group Ticket
13    | Exchange Adjustment
14    | SPD/Air Freight
15    | In-flight Adjustment
16    | Agency Passenger Ticket
17    | Agency Tour Order/Voucher
18    | Agency Misc. Charge Order (MCO)
19    | Agency Exchange Order
20    | Agency Group Ticket
21    | Debit Adjustment Duplicate Refund/Use
22    | In-flight Merchandise Ordered
23    | Catalogue Merchandise Ordered
24    | In-flight Phone Charges
25    | Frequent Flyer Fee/Purchase
26    | Kennel Charge
27    | Animal Transportation Charge
28    | Firearms Case
29    | Upgrade Charge
30    | Credit Unused Transportation
31    | Credit Class of Service Adjustment
32    | Credit Denied Boarding
33    | Credit Misc. Refund
34    | Credit Lost Ticket Refund
35    | Credit Exchange Refund
36    | Credit Overcharge Adjustment
37    | Credit Multiple Unused Tickets
38    | Exchange Order
39    | Self-Service Ticket(s)
41    | In-flight Duty Free Purchase
42    | Senior Citizen Discount Booklets
43    | Club Membership Fee
44    | Coupon Book
45    | In-flight Charges
46    | Tour Deposit
47    | Frequent Flyer Overnight Delivery Charge
48    | Frequent Flyer Fulfillment
49    | Small Package Delivery
50    | Vendor Sale
51    | Miscellaneous Tax(es) Fee(s)
52    | Travel Agency Fee
60    | Vendor Refund Credit
64    | Duty Free Sale
65    | Preferred Seat Upgrade
66    | Cabin Upgrade
67    | Lounge/Club Access or Day Pass
68    | Agent Assisted Reservation. Ticketing Fee
69    | Ticket Change or Cancel Fee
70    | Trip Insurance
71    | Unaccompanied Minor
72    | Standby Fee
73    | Curbside Baggage
74    | Inflight Medical Equipment
75    | Ticket or Pass Print Fee
76    | Checked Sporting/Special Equipment
77    | Dry Ice Fee
78    | Mail/Postage Fee
79    | Club Membership Fee - Temporary/Trial
80    | Frequent Flyer Activation/Reinstatement
81    | Gift Certificate
82    | Onboard/Inflight Prepaid Voucher
83    | Optional Services Fee
84    | Advanced Purchase - Excess Baggage
85    | Advanced Purchase - Preferred Seat Upgrade
86    | Advanced Purchase - Cabin Upgrade
87    | Advanced Purchase - Optional Services
88    | WiFi
89    | Packages
90    | Inflight Entertainment/Internet Access
91    | Overweight Bag Fee
92    | Sleep Sets
93    | Special Purchase Fee
        Enum: same as `transaction.airline.documentType` in "Commerce Engine For On Premise" (82 values)
      - `transaction.airline.electronicTicketIndicator` (string, required)
        Indicates if an electronic ticket was issued.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.internetIndicator` (string, required)
        Indicates if this is an internet transaction.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.issueDate` (string, required)
        The date the ticket was issued to the customer. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.numberOfCities` (number, required)
        The number of airports or cities for each leg on the ticket (including origination and destination cities).
      - `transaction.airline.numberOfCarriers` (number, required)
        This field contains the number of airline carriers.
      - `transaction.airline.numberOfPassengers` (number, required)
        The number of passengers in the transaction.
      - `transaction.airline.passengerArrivalDate` (string, required)
        Date that the ticket holder is scheduled to arrive at their destination at the time of issuance of the original ticket. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerDepartureDate` (string, required)
        Date that the ticket holder is scheduled to depart at the time of issuance of the original ticket. The date may be a future one.  The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerNameRecord` (string, required)
        A passenger name record (PNR) is a record in the database of a computer reservation system (CRS) that contains the itinerary for a passenger or a group of passengers travelling together
      - `transaction.airline.restrictedTicketIndicator` (string, required)
        Indicates whether this ticket is non-refundable.

Value  | Description       
-------|-------------------
0      | No restriction
1      | Restricted (non-refundable) ticket
        Enum: same as `transaction.airline.restrictedTicketIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.ticketChangeIndicator` (string, required)
        Indicates why a ticket was changed.  This field should contain spaces or one of the below codes.

Value  | Description 
-------|---------------
C      | Change to existing ticket
N      | New ticket
        Enum: same as `transaction.airline.ticketChangeIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.ticketTranType` (string, required)
        This field contains the ticket transaction type code assigned to this transaction.

Value  | Description 
-------|---------------
TKT    | Ticket Purchase
REF    | Refund
EXC    | Exchange Ticket
MSC    | Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only)
        Enum: same as `transaction.airline.ticketTranType` in "Commerce Engine For On Premise" (4 values)
      - `transaction.airline.tickets` (array, required)
        Array of ticket number and passenger name. Note: At least one instance of ticket number and passenger name info should be provided.
      - `transaction.airline.tickets.passengerName` (string, required)
        Name of the passenger to whom the ticket was issued.  This field contains the Passenger Name in format:

SURNAME FIRSTNAME MIDDLEINITIAL TITLE

Example: "Doe Jane M Mrs"
      - `transaction.airline.tickets.ticketNumber` (string, required)
        The ticket number provided by the Carrier for the passenger.
      - `transaction.airline.tickets.ticketFare` (number, required)
        Ticket fare is the total amount for each ticket, including service fee or any other fee for each ticket.
      - `transaction.airline.flightLegs` (array, required)
        Array of flight trip leg info. Maximun 4 legs to a trip allowed. Note: At least one instance of flight trip leg info should be provided.
      - `transaction.airline.flightLegs.carrierCode` (string, required)
        Code indicating name of carrier (United Airlines, Jet Blue, etc.) for the leg.
      - `transaction.airline.flightLegs.destAirportCode` (string, required)
        Indicates destination city's airport code for the leg.
      - `transaction.airline.flightLegs.fare` (number, required)
        This field contains the total Fare for this trip segment. This is not the total amount billed to the customer.
      - `transaction.airline.flightLegs.fareBasis` (string, required)
        This field contains primary and secondary discount codes that indicate the class of service and fare level associated with the ticket for the leg. Truncate at 24 bytes, if necessary.
      - `transaction.airline.flightLegs.flightNumber` (string, required)
        Number of the airline flight to be taken on Leg of the trip.
      - `transaction.airline.flightLegs.legArrivalDateTime` (string, required)
        The date and time the flight is scheduled to arrive for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.legDepartureDateTime` (string, required)
        The date and time the flight is scheduled to depart for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.originAirportCode` (string, required)
        Indicates origination city's airport code for the leg.
      - `transaction.airline.flightLegs.serviceClass` (string, required)
        Indicates service class for leg.

Value  | Description 
-------|---------------
FC     | First Class
BC     | Business Class
EC     | Economy/Coach Class
      - `transaction.airline.flightLegs.stopOverCode` (string, required)
        Indicates whether a stopover is allowed on this ticket for leg. The entry must be a D, O, or X.

Value  | Description 
-------|---------------
O      | Stopover allowed
X      | Stopover not allowed
D      | Destination point
      - `transaction.airline.flightLegs.tripLegInfo` (string, required)
        Description of leg or stage of trip.
      - `transaction.airline.flightLegs.couponNumber` (number)
        Number of coupons in the ticket for the leg.
      - `transaction.airline.typeIndicator` (string, required)
        Indicates if this ticket is a round trip, multi-city, or one-way ticket. 

Value  | Description 
-------|---------------
R      | Round-Trip
O      | One Way
M      | Multi-City
        Enum: same as `transaction.airline.typeIndicator` in "Commerce Engine For On Premise" (3 values)
      - `transaction.airline.ancillaryServices` (array)
        Array of ancillary service code and fees.

Conditional: Send if any ancillary services were charged.
      - `transaction.airline.ancillaryServices.serviceCode` (string, required)
        This field describes the type of service that has been provided.

Value | Description 
------|---------------
BF    | Bundled Service
BG    | Baggage Fee
CF    | Change Fee
CG    | Cargo
CO    | Carbon Offset
FF    | Frequent Flyer
GF    | Gift Card
GT    | Ground Transport
IE    | In-Flight Entertainment
LG    | Lounge
MD    | Medical
ML    | Meal/Beverage
OT    | Other
PA    | Passenger Assist Fee
PT    | Pets
SA    | Seat Fees
SB    | Standby
SF    | Service Fee
ST    | Store
TS    | Travel Service
UN    | Unaccompanied Travel
UP    | Upgrades
WI    | Wi-Fi
        Enum: same as `transaction.airline.ancillaryServices.serviceCode` in "Commerce Engine For On Premise" (23 values)
      - `transaction.airline.ancillaryServices.serviceFee` (number, required)
        This field contains the amount associated with the value provided in ancillary Service Code.
      - `transaction.airline.travelAgencyCode` (string)
        Code identifying travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.travelAgencyName` (string)
        Name of travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.exchangeTicketNumber` (string)
        The original ticket number that was replaced by a new ticket number.
      - `transaction.cardOnFile` (object)
        Conditional: Send this object when the transaction being performed is using a card on file or when the request will result in storing a card on file.

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for more information.
      - `transaction.cardOnFile.type` (string)
        This field specifies the type of the card-on-file transaction.

Below is a table showing the valid values for use cases where the cardholder is entering their card data to store on file.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| S01    | Cardholder | No        | Yes       | Used when the initial transaction/card verification request is not for a recurring payment.                                                                                                                                                                                                                                                                                        |
| S02    | Cardholder | Yes       | Yes       | Used when the initial transaction/card verification request is for a recurring payment. Requires sending cardOnFile.recurringFrequency and cardOnFile.recurringExpiry                                                                                                                                                                                              |

Below is a table showing the valid values for uses cases where you already have a card on file and are using that existing card to process a transaction.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| U01    | Cardholder | No        | Yes       | Unscheduled transaction using the card on file initiated by the cardholder                                                                                                                                                                                                                                                                                      |
| U02    | Merchant   | No        | No        | Unscheduled transaction using the card on file initiated by the merchant                                                                                                                                                                                                                                                                                        |
| U03    | Merchant   | Yes       | No        | Merchant initiated recurring payment using the card on file                                                                                                                                                                                                                                                                                                     |
| U04    | Merchant   | No        | No        | Identifies a transaction as a Reauthorization COF transaction.                                                                                                                                                                                                                                                                                                  |
| U05    | Merchant   | No        | No        | Identifies a transaction as a Resubmission COF transaction. Only certain merchant categories are able to send a resubmission, and it can only be done if the original authorization attempt was declined due to insufficient funds.                                                                                                                             |
| U06    | Merchant   | No        | No        | Identifies a transaction as an Estimated Authorization COF transaction.                                                                                                                                                                                                                                                                                         |
| U07    | Merchant   | No        | No        | Identifies a transaction as a Delayed Charges COF transaction. For example, a hotel might charge a customer for room damages after the guest has already checked out.                                                                                                                                                                                           |
| U08    | Merchant   | No        | No        | Identifies a transaction as an Incremental COF transaction. For example, a hotel which authorized a customer’s card for one night at check-in might increase the authorization amount to cover two nights when the customer decides to extend their stay. Shift4 automatically detects this scenario and sends the appropriate value to the processor. |
| U09    | Merchant   | No        | No        | Identifies a transaction as a No Show COF transaction. For example, a hotel might charge a customer who does not show up for a booked stay.                                                                                                                                                                                                                     |

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for additional details.
        Enum: same as `transaction.cardOnFile.type` in "Commerce Engine For On Premise" (11 values)
      - `transaction.cardOnFile.recurringExpiry` (string)
        Date after which no further authorizations shall be performed. This field is limited to 8 characters, and the accepted format is YYYYMMDD.

Conditional: This field is required if it's the first recurring transaction (cardOnFile.type = S02). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.
      - `transaction.cardOnFile.recurringFrequency` (string)
        Indicates the minimum number of days between authorizations.

Conditional: 'This field is required if it's the first recurring transaction (cardOnFile.type = S02). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.
      - `transaction.cardOnFile.transactionId` (string)
        This field is returned in the initial COF response, and ties subsequent COF transactions to the original authorization.

For example, if a merchant runs a Sale on a card for the first time, they will receive a transactionId back in the response.  A month later, when the merchant wants to perform an additional Sale with the card on file, they would send a Sale request including the transactionId they received from the first sale.

Conditional: Must be sent in subsequent COF requests if you are not processing with a Global Token Vault token. If using Global Token Vault tokens then this field is not required
      - `transaction.hotel` (object)
        Conditional: Utilize this object for Hotel transactions
        Example: {"estimatedDays":5}
      - `transaction.hotel.estimatedDays` (integer)
        Used to communicate the estimated number of days of a guest’s stay. This value is included in an [Authorization](/apis/payments-platform-rest/openapi/transactions/transactionsauthorization) request for a consumer’s hotel stay.
        Example: 5
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `device` (object, required)
        Example: {"cloud":true,"manufacturer":"PAX","serialNumber":"1170301234"}
      - `device.cloud` (boolean, required)
        Indicates the transaction will be processed via the Commerce Engine solution for cloud based POS/PMS systems. Value must be sent as true in order to route the request to the payment device at the merchant location.
        Example: true
      - `device.manufacturer` (string, required)
        Specifies the company which manufactured the device.
        Enum: "Ingenico", "Innowi", "PAX", "Verifone", "Castles", "Miura"
      - `device.serialNumber` (string, required)
        Specifies the serial number of the device.
        Example: "1170301234"
      - `customer` (object)
      - `customer.addressLine1` (string)
        Cardholder’s street address exactly as it appears on their billing statement. This field is used in AVS.
      - `customer.firstName` (string)
        Specifies a consumer’s first name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the customer object, the consumer's name will be returned in the customer object if the name is present in the card's EMV or track data.
      - `customer.middleName` (string)
        Specifies a consumer’s middle name.
      - `customer.lastName` (string)
        Specifies a consumer’s last name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the customer object, the consumer's name will be returned in the customer object if the name is present in the card's EMV or track data.
      - `customer.postalCode` (string)
        Cardholder’s ZIP/postal code from their billing statement. This field is used in AVS. Do not include special characters.

Note: This field only allows alphanumeric characters (a-z, A-Z, 0-9). Special characters including - are not allowed. If you are sending in zip+4 you must not include the dash so 89134-1234 would be sent as 891341234
      - `customer.emailAddress` (string)
        Customer email address.
      - `customer.ipAddress` (string)
        Public source IP Address where the request originates, not the IP Address of the web server.
      - `card` (object)
        Example: {"present":"Y"}
      - `card.present` (string)
        Conditional: Send in the initial authorization/sale request

Indicates whether a card was present (‘Y’) or not (‘N’) at the time a transaction took place. This should be set appropriately in the initial authorization/sale request.  In subsequent requests, this field should be left blank or should not be sent.

Note: Subsequent request here does not apply to the secondary request for card on file type transactions or reuse of the same card. An example of a subsequent request would be a capture after an authorization. You would not include card.present in the capture, which is the subsequent request. Another example is when performing an incremental authorization where you perform an authorization, followed by an incremental authorization then a capture. The second authorization (incremental) and the capture are the subsequent requests where you would not include card.present.
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `card.type` (string)
        An abbreviation used to specify the type of card that will be used when processing a transaction.  If an interface sends a value that is not listed here, that value will be ignored.

Value| Description
-----|------------
CC   | When using a UTG-controlled device, this value will force a card to process as credit.
DB   | When using a UTG-controlled device, this value will force a card to process as debit.  When using a non-UTG-controlled PIN pad, this value must be sent when processing a debit transaction.
GC   | Gift Card
HF   | HSA/FSA Card
PL   | Private Label
YC   | IT’S YOUR CARD
        Enum: same as `card.type` in "Commerce Engine For On Premise" (6 values)
      - `receiptColumns` (integer)
        Send this field if you want Shift4 to format the receipt text instead of returning individual fields. The value sent will correlate to the column width of the formatted receipt that we return. (This also allows the receipt text to wrap to fit the paper size of the printed receipt.) See the [Printing Receipts](/guides/core-concepts/printing-receipts) section of this document for more information on formatted receipts.
      - `currencyCode` (string)
        Transaction currency code. See the [Currency Codes](/guides/appendices/currency-codes) section for details.

Note: This is currently supported when processing for a merchant outside of the US and Canada. If processing for a US or Canadian merchant then this field will be ignored and the transaction will process in the merchant's configured currency.
      - `apiOptions` (array)
        API Options modify the request being made. See the [API Options](/guides/appendices/api-options.md) section for more information.
        Example: ["ALLOWPARTIALAUTH"]
      - `statementSuffix` (string)
        Custom description that will be appended to the merchant name on the customer's statement. For most card brands, the merchant DBA name can be a maximum of 25 characters. Sending this value will cause the merchant name to be truncated to 9 characters. Shift4 will add an asterisk between the merchant name and the statementSuffix value.

For example, for a merchant named Joe's Warehouse Emporium that processes a transaction with statementSuffix value of KDNYZUHQ1, the merchant statement will show as Joe's War*KDNYZUHQ1.

Note: The value that displays on customer statements from card issuers is beyond Shift4's control. We will submit the transaction data as described above, however issuers may modify or truncate that data as they see fit. To best accommodate different issuer limitations, we will truncate the merchant name to the minimum possible value (9 characters) in order to attempt to leave the most room for the statementSuffix to populate on issuer statements.
    - UTG Controlled Device:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
        Example: "2021-04-15T09:18:23.283-07:00"
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested. All other fields are for informational purposes and must also be included in the total field. For example, a purchase of $100 with a $20 tip and $8 tax would be 128.00 in the total field, 20.00 in the tip field and 8.00 in the tax field.

Note: For merchants that are configured to allow multiple currencies, the amount  fields can specify up to three decimal places. However, the number of decimal  places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
        Example: {"tax":15,"total":140}
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
        Example: 140
      - `amount.tax` (number, required)
        The amount of sales tax charged for a transaction. The tax amount is used by businesses to track tax expenses for accounting purposes. Identifying the tax amount also helps consumers understand the total amount that they were billed.  This field is part of Level 2 card data.
        Example: 15
      - `amount.taxIndicator` (string)
        Value|Description
-----|-----------
Y    | Tax is included
N    | Tax is not included
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `amount.cashback` (number)
        Specifies the cashback amount in a transaction. When using a UTG-controlled PIN pad with the ALLOWCASHBACK API Option, this field will return the cashback amount requested by the consumer. The interface can also send the desired cashback amount in a request by adding it to the amount.total and including it in the amount.cashback field. This will bypass prompting the consumer for a cashback amount.
      - `amount.iiasAmounts` (array)
        Conditional: Send in the request if processing for a health care merchant.

For Vision related charges you must send only iiasAmounts.type = 4V and the corresponding iiasAmounts.amount value.

For all other charges, the first entry in the array should have an amount representing the total of all healthcare costs, and iiasAmounts.type = 4S.  Any subsequent entries should contain the subtotal for each of the other expense types involved in this transaction.
      - `amount.iiasAmounts.amount` (number)
        The subtotal for this type of healthcare expenses.
      - `amount.iiasAmounts.type` (string)
        This code classifies eligible healthcare expenses.

Value|Description
-----|-----------
4O   | Cash Disbursement (Discover Only) – Amount of Cash Back Being Requested
4S   | Healthcare (Visa/MC Only) – Qualified Medical Expenses or Over-the-Counter
4T   | Transit (Visa Only) – Transit Fare Media (e.g., Commuter and Parking Passes, Mass Transit Vouchers, and Tickets)
4U   | RX (Visa/MC Only)
4V   | Vision (Visa Only)
4W   | Clinical (Visa Only)
4X   | Dental (Visa Only)
        Enum: same as `amount.iiasAmounts.type` in "Commerce Engine For On Premise" (7 values)
      - `amount.tip` (number)
        Conditional: Send in the request if a tip is included.

The tip amount of the transaction.
      - `amount.checkTotal` (number)
        Optional field specifying the total amount of the entire bill/invoice that this transaction is part of. It can be larger than amount.total in scenarios where the check is being split or if a portion of the check was already paid in cash or another form of payment.
      - `clerk` (object, required)
        Example: {"numericId":1576}
      - `clerk.numericId` (integer, required)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
        Example: 1576
      - `transaction` (object, required)
        Example: {"hotel":{"estimatedDays":5},"invoice":"192029","authorizationCode":"189746","notes":"Transaction notes are added here","purchaseCard":{"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}}
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
        Example: "192029"
      - `transaction.purchaseCard` (object, required)
        Example: {"customerReference":"D019D09309F2","destinationPostalCode":"94719","productDescriptors":["Hamburger","Fries","Soda","Cookie"]}
      - `transaction.purchaseCard.customerReference` (string, required)
        A unique value used to identify the consumer or transaction. If a merchant has a significant amount of revenue from purchasing card customers, the interface would use this field to collect the consumer’s purchase order or employee identification number. In lodging transactions, this may be unique transaction details, such as a reservation code or third-party booking source.  This field is part of Level 2 card data.
        Example: "D019D09309F2"
      - `transaction.purchaseCard.destinationPostalCode` (string, required)
        When items are shipped, the ZIP/postal code to which merchandise will be shipped; otherwise, the ZIP/postal code where the goods or services are rendered.  This field is part of Level 2 card data.
        Example: "94719"
      - `transaction.purchaseCard.productDescriptors` (array, required)
        A text description of the items purchased or services sold. This can be a generic text description of what the merchant sells (such as “Groceries”) or specific transaction data (such as the name of the item sold). At least one product descriptor field is required in a sale or authorization request.

Note: The productDescriptors array is limited to 4 elements. Each element can contain a maximum of 40 characters.
        Example: ["Hamburger","Fries","Soda","Cookie"]
      - `transaction.authorizationCode` (string, required)
        The authorization code provided by the consumer’s issuing bank. It is provided in a response if an online authorization or sale request is approved. Following a referral response, it is also specified in [Manual Sale](/apis/payments-platform-rest/openapi/transactions/manualsale) requests.
        Example: "189746"
      - `transaction.manualTranId` (string)
        This is typically used in a Referral. If a ManualTranID is returned by the issuer with the Auth code, it should be sent to the processor in the ManualTranid field.
      - `transaction.notes` (string)
        A free-form notes field that supports the use of HTML tags.  This can be used for reference in [Lighthouse Transaction Manager](https://ltm.shift4test.com/) and is not sent to the authorization host. Escaped quotation marks should not be sent in the Notes field.
        Example: "Transaction notes are added here"
      - `transaction.businessDate` (string)
        Desired business date of a transaction. Include when overriding the existing business date of a transaction. The overriding date may be earlier or later than the existing date. (yyyy-mm-dd)
      - `transaction.amex` (object)
      - `transaction.amex.propertyCode` (string)
        The code that contains a Merchant-assigned store or location number (or name) that uniquely identifies where the transaction took place.
      - `transaction.auto` (object)
        Conditional: Utilize this object for Auto Rental transactions
      - `transaction.auto.estimatedDays` (integer)
        Estimated contract length of car rental.
      - `transaction.airline` (object)
        Conditional: Utilize this object for Airline transactions in Authorization/Sale requests when possible. If unable to provide this data at Authorization, this object must be sent in subsequent Capture requests for the transaction.
      - `transaction.airline.carrierCode` (string, required)
        The code of the airline carrier issuing the ticket.
      - `transaction.airline.carrierName` (string, required)
        The name of the airline carrier issuing the ticket.
      - `transaction.airline.conjunctionTicketIndicator` (string, required)
        Indicates whether the itinerary contains more than four segments of travel.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.documentType` (string, required)
        This field contains the airline Document Type code, which indicates the purpose of this transaction. This information may appear on the descriptive bill on the Cardmember's statement, or be used to resolve billing inquiries and disputes. The codes entered in the Transaction Type and Document Type fields are used together to describe the purpose of this transaction.

Value | Description 
------|---------------
01    | Passenger Ticket
02    | Additional Collection
03    | Excess Baggage
04    | Misc. Charge Order (MCO) / Prepaid Ticket Auth
05    | Special Service Ticket
06    | Supported Refund
07    | Unsupported Refund
08    | Lost Ticket Application
09    | Tour Order Voucher
10    | Ticket by Mail
11    | Undercharge Adjustment
12    | Group Ticket
13    | Exchange Adjustment
14    | SPD/Air Freight
15    | In-flight Adjustment
16    | Agency Passenger Ticket
17    | Agency Tour Order/Voucher
18    | Agency Misc. Charge Order (MCO)
19    | Agency Exchange Order
20    | Agency Group Ticket
21    | Debit Adjustment Duplicate Refund/Use
22    | In-flight Merchandise Ordered
23    | Catalogue Merchandise Ordered
24    | In-flight Phone Charges
25    | Frequent Flyer Fee/Purchase
26    | Kennel Charge
27    | Animal Transportation Charge
28    | Firearms Case
29    | Upgrade Charge
30    | Credit Unused Transportation
31    | Credit Class of Service Adjustment
32    | Credit Denied Boarding
33    | Credit Misc. Refund
34    | Credit Lost Ticket Refund
35    | Credit Exchange Refund
36    | Credit Overcharge Adjustment
37    | Credit Multiple Unused Tickets
38    | Exchange Order
39    | Self-Service Ticket(s)
41    | In-flight Duty Free Purchase
42    | Senior Citizen Discount Booklets
43    | Club Membership Fee
44    | Coupon Book
45    | In-flight Charges
46    | Tour Deposit
47    | Frequent Flyer Overnight Delivery Charge
48    | Frequent Flyer Fulfillment
49    | Small Package Delivery
50    | Vendor Sale
51    | Miscellaneous Tax(es) Fee(s)
52    | Travel Agency Fee
60    | Vendor Refund Credit
64    | Duty Free Sale
65    | Preferred Seat Upgrade
66    | Cabin Upgrade
67    | Lounge/Club Access or Day Pass
68    | Agent Assisted Reservation. Ticketing Fee
69    | Ticket Change or Cancel Fee
70    | Trip Insurance
71    | Unaccompanied Minor
72    | Standby Fee
73    | Curbside Baggage
74    | Inflight Medical Equipment
75    | Ticket or Pass Print Fee
76    | Checked Sporting/Special Equipment
77    | Dry Ice Fee
78    | Mail/Postage Fee
79    | Club Membership Fee - Temporary/Trial
80    | Frequent Flyer Activation/Reinstatement
81    | Gift Certificate
82    | Onboard/Inflight Prepaid Voucher
83    | Optional Services Fee
84    | Advanced Purchase - Excess Baggage
85    | Advanced Purchase - Preferred Seat Upgrade
86    | Advanced Purchase - Cabin Upgrade
87    | Advanced Purchase - Optional Services
88    | WiFi
89    | Packages
90    | Inflight Entertainment/Internet Access
91    | Overweight Bag Fee
92    | Sleep Sets
93    | Special Purchase Fee
        Enum: same as `transaction.airline.documentType` in "Commerce Engine For On Premise" (82 values)
      - `transaction.airline.electronicTicketIndicator` (string, required)
        Indicates if an electronic ticket was issued.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.internetIndicator` (string, required)
        Indicates if this is an internet transaction.

Value  | Description       
-------|-------------------
Y      | Yes
N      | No
        Enum: same as `amount.taxIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.issueDate` (string, required)
        The date the ticket was issued to the customer. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.numberOfCities` (number, required)
        The number of airports or cities for each leg on the ticket (including origination and destination cities).
      - `transaction.airline.numberOfCarriers` (number, required)
        This field contains the number of airline carriers.
      - `transaction.airline.numberOfPassengers` (number, required)
        The number of passengers in the transaction.
      - `transaction.airline.passengerArrivalDate` (string, required)
        Date that the ticket holder is scheduled to arrive at their destination at the time of issuance of the original ticket. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerDepartureDate` (string, required)
        Date that the ticket holder is scheduled to depart at the time of issuance of the original ticket. The date may be a future one.  The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.passengerNameRecord` (string, required)
        A passenger name record (PNR) is a record in the database of a computer reservation system (CRS) that contains the itinerary for a passenger or a group of passengers travelling together
      - `transaction.airline.restrictedTicketIndicator` (string, required)
        Indicates whether this ticket is non-refundable.

Value  | Description       
-------|-------------------
0      | No restriction
1      | Restricted (non-refundable) ticket
        Enum: same as `transaction.airline.restrictedTicketIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.ticketChangeIndicator` (string, required)
        Indicates why a ticket was changed.  This field should contain spaces or one of the below codes.

Value  | Description 
-------|---------------
C      | Change to existing ticket
N      | New ticket
        Enum: same as `transaction.airline.ticketChangeIndicator` in "Commerce Engine For On Premise" (2 values)
      - `transaction.airline.ticketTranType` (string, required)
        This field contains the ticket transaction type code assigned to this transaction.

Value  | Description 
-------|---------------
TKT    | Ticket Purchase
REF    | Refund
EXC    | Exchange Ticket
MSC    | Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only)
        Enum: same as `transaction.airline.ticketTranType` in "Commerce Engine For On Premise" (4 values)
      - `transaction.airline.tickets` (array, required)
        Array of ticket number and passenger name. Note: At least one instance of ticket number and passenger name info should be provided.
      - `transaction.airline.tickets.passengerName` (string, required)
        Name of the passenger to whom the ticket was issued.  This field contains the Passenger Name in format:

SURNAME FIRSTNAME MIDDLEINITIAL TITLE

Example: "Doe Jane M Mrs"
      - `transaction.airline.tickets.ticketNumber` (string, required)
        The ticket number provided by the Carrier for the passenger.
      - `transaction.airline.tickets.ticketFare` (number, required)
        Ticket fare is the total amount for each ticket, including service fee or any other fee for each ticket.
      - `transaction.airline.flightLegs` (array, required)
        Array of flight trip leg info. Maximun 4 legs to a trip allowed. Note: At least one instance of flight trip leg info should be provided.
      - `transaction.airline.flightLegs.carrierCode` (string, required)
        Code indicating name of carrier (United Airlines, Jet Blue, etc.) for the leg.
      - `transaction.airline.flightLegs.destAirportCode` (string, required)
        Indicates destination city's airport code for the leg.
      - `transaction.airline.flightLegs.fare` (number, required)
        This field contains the total Fare for this trip segment. This is not the total amount billed to the customer.
      - `transaction.airline.flightLegs.fareBasis` (string, required)
        This field contains primary and secondary discount codes that indicate the class of service and fare level associated with the ticket for the leg. Truncate at 24 bytes, if necessary.
      - `transaction.airline.flightLegs.flightNumber` (string, required)
        Number of the airline flight to be taken on Leg of the trip.
      - `transaction.airline.flightLegs.legArrivalDateTime` (string, required)
        The date and time the flight is scheduled to arrive for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.legDepartureDateTime` (string, required)
        The date and time the flight is scheduled to depart for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
      - `transaction.airline.flightLegs.originAirportCode` (string, required)
        Indicates origination city's airport code for the leg.
      - `transaction.airline.flightLegs.serviceClass` (string, required)
        Indicates service class for leg.

Value  | Description 
-------|---------------
FC     | First Class
BC     | Business Class
EC     | Economy/Coach Class
      - `transaction.airline.flightLegs.stopOverCode` (string, required)
        Indicates whether a stopover is allowed on this ticket for leg. The entry must be a D, O, or X.

Value  | Description 
-------|---------------
O      | Stopover allowed
X      | Stopover not allowed
D      | Destination point
      - `transaction.airline.flightLegs.tripLegInfo` (string, required)
        Description of leg or stage of trip.
      - `transaction.airline.flightLegs.couponNumber` (number)
        Number of coupons in the ticket for the leg.
      - `transaction.airline.typeIndicator` (string, required)
        Indicates if this ticket is a round trip, multi-city, or one-way ticket. 

Value  | Description 
-------|---------------
R      | Round-Trip
O      | One Way
M      | Multi-City
        Enum: same as `transaction.airline.typeIndicator` in "Commerce Engine For On Premise" (3 values)
      - `transaction.airline.ancillaryServices` (array)
        Array of ancillary service code and fees.

Conditional: Send if any ancillary services were charged.
      - `transaction.airline.ancillaryServices.serviceCode` (string, required)
        This field describes the type of service that has been provided.

Value | Description 
------|---------------
BF    | Bundled Service
BG    | Baggage Fee
CF    | Change Fee
CG    | Cargo
CO    | Carbon Offset
FF    | Frequent Flyer
GF    | Gift Card
GT    | Ground Transport
IE    | In-Flight Entertainment
LG    | Lounge
MD    | Medical
ML    | Meal/Beverage
OT    | Other
PA    | Passenger Assist Fee
PT    | Pets
SA    | Seat Fees
SB    | Standby
SF    | Service Fee
ST    | Store
TS    | Travel Service
UN    | Unaccompanied Travel
UP    | Upgrades
WI    | Wi-Fi
        Enum: same as `transaction.airline.ancillaryServices.serviceCode` in "Commerce Engine For On Premise" (23 values)
      - `transaction.airline.ancillaryServices.serviceFee` (number, required)
        This field contains the amount associated with the value provided in ancillary Service Code.
      - `transaction.airline.travelAgencyCode` (string)
        Code identifying travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.travelAgencyName` (string)
        Name of travel agency if the ticket was issued by a travel agency.

Conditional: Send if a travel agency service was used.
      - `transaction.airline.exchangeTicketNumber` (string)
        The original ticket number that was replaced by a new ticket number.
      - `transaction.cardOnFile` (object)
        Conditional: Send this object when the transaction being performed is using a card on file or when the request will result in storing a card on file.

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for more information.
      - `transaction.cardOnFile.type` (string)
        This field specifies the type of the card-on-file transaction.

Below is a table showing the valid values for use cases where the cardholder is entering their card data to store on file.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| S01    | Cardholder | No        | Yes       | Used when the initial transaction/card verification request is not for a recurring payment.                                                                                                                                                                                                                                                                                        |
| S02    | Cardholder | Yes       | Yes       | Used when the initial transaction/card verification request is for a recurring payment. Requires sending cardOnFile.recurringFrequency and cardOnFile.recurringExpiry                                                                                                                                                                                              |

Below is a table showing the valid values for uses cases where you already have a card on file and are using that existing card to process a transaction.

| Value  | Initiator  | Recurring | 3D Secure | Description                                                                                                                                                                                                                                                                                                                                                     |
|--------|------------|-----------|-----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
[...]
